# Static website of the [FOKUS Aargau](https://fokus.ag) project

[![Netlify Status](https://api.netlify.com/api/v1/badges/1df29dff-4faa-486f-930e-a7ad52e58e1c/deploy-status)](https://app.netlify.com/sites/fokus-ag/deploys)

This website is built using [Hugo](https://gohugo.io/) and the R package [blogdown](https://bookdown.org/yihui/blogdown).

<!-- TOC BEGIN -- leave this comment untouched to allow auto update -->

## Table of contents

-   [Building R Markdown sites/posts](#-building-r-markdown-sitesposts)
-   [Preview the site](#-preview-the-site)
-   [Control (publication) date(s)](#-control-publication-dates)
-   [blogdown peculiarities](#-blogdown-peculiarities)
    -   [Soft hyphens](#-soft-hyphens)
    -   [Smart punctuation](#-smart-punctuation)
    -   [Enable/disable Pandoc extensions](#-enabledisable-pandoc-extensions)
    -   [Hugo shortcodes](#-hugo-shortcodes)
    -   [Plain HTML](#-plain-html)
-   [Image optimization](#-image-optimization)
    -   [JPEG](#-jpeg)
    -   [PNG](#-png)
    -   [SVG](#-svg)
-   [Font icons](#-font-icons)
-   [Analytics](#-analytics)
-   [Shared assets](#-shared-assets)
    -   [Counter.dev JS](#-counter-dev-js)
    -   [GoatCounter JS](#-goatcounter-js)
-   [License](#-license)

<!-- TOC END -- leave this comment untouched to allow auto update -->

## [🠅](#table-of-contents) Building R Markdown sites/posts

To build all `.Rmd` sites and posts at once to HTML files (which then can be processed by Hugo), run (in a shell):

``` sh
Rscript -e 'blogdown::build_site(run_hugo = FALSE, build_rmd = TRUE)'
```

To only build a single site/post (`content/daten.Rmd` in the example), run (in a shell):

``` r
Rscript -e 'blogdown:::build_rmds("content/daten.Rmd")'
```

## [🠅](#table-of-contents) Preview the site

To preview the site using Hugo, run from the root of the repository (in a shell):

``` sh
# `--disableFastRender` results in complete instead of incremental rebuilds (more reliable)
hugo server --buildDrafts --disableFastRender
```

## [🠅](#table-of-contents) Control (publication) date(s)

Hugo supports 4 different date keys in the [front matter](https://gohugo.io/content-management/front-matter/) of posts:

-   `date`
-   `lastmod`
-   `publishDate`
-   `expiryDate`

How they are cross-filled when left empty is listed [in this comment](https://github.com/gohugoio/hugo/issues/3977#issuecomment-379154169) from Hugo's lead
developer *bep*.

To publish a post in the future, it's normally sufficient to just set the `date` key to that future point in time. Currently there's a build
triggered[^readme-1] every day at 08:01 [CE(S)T](https://en.wikipedia.org/wiki/Central_European_Time), so if you set the time in `date` to something **before**
08:01 CE(S)T, the post will be online at the specified date shortly after 08:01 CE(S)T.

[^readme-1]: In general, results by Guetzli are typically 20--30 % smaller than images of equivalent quality generated by
    [libjpeg](https://en.wikipedia.org/wiki/Libjpeg).

## [🠅](#table-of-contents) blogdown peculiarities

While normal Hugo sites/posts written in plain Markdown (`.md`) are processed by Hugo's built-in Markdown rendering engine
[Goldmark](https://gohugo.io/getting-started/configuration-markup/#goldmark), sites/posts written in R Markdown (`.Rmd`) are [processed by the R packages
blogdown, bookdown and rmarkdown](https://bookdown.org/yihui/blogdown/output-format.html) and fed to [Pandoc](https://pandoc.org/) to do the actual conversion
to HTML.

This leads to various more or less annoying differences when writing sites/posts in R Markdown. Some of them are discussed below.

### [🠅](#table-of-contents) Soft hyphens

While UTF-8 soft hyphens in the **body of R Markdown documents** do not cause any problem as such, they can cause RStudio to stumble sometimes and mess up the
character encoding of the document. If this happens, save the document explicitly as UTF-8 (<kbd>File</kbd> → <kbd>Save with Encoding...</kbd>) and fix the soft
hyphens in another editor like Atom.

In **YAML header** strings, soft hyphens have to be written as escaped unicode code points like this: `\u00ad`

### [🠅](#table-of-contents) Smart punctuation

Pandoc is configured to apply [smart punctuation](https://pandoc.org/MANUAL.html#typography), i.e. replace `"` with `„`/`“` and `--` with `–` etc. To disable
this kind of auto-replacement for a single character, just escape it (e.g. `\"`).

### [🠅](#table-of-contents) Enable/disable Pandoc extensions

You can enable/disable [Pandoc extensions](https://pandoc.org/MANUAL.html#extensions) for specific sites/posts as you like. To disable [auto-hyperlinking all
absolute URIs (even when not surrounded by pointy braces `<...>`)](https://pandoc.org/MANUAL.html#extension-autolink_bare_uris) for example, add the following
to the YAML metadata block:

``` yaml
output:
  blogdown::html_page:
    md_extensions: "-autolink_bare_uris"
```

### [🠅](#table-of-contents) Hugo shortcodes

You cannot simply write [Hugo shortcodes](https://gohugo.io/content-management/shortcodes/) as `{{< shortcode >}}` in R Markdown, because Pandoc is not aware of
Hugo shortcodes, and may convert special characters so that Hugo can no longer recognize the shortcodes (e.g. `<` will be converted to `&lt;`). In order to use
shortcodes from inside `.Rmd` sites/posts, employ the dedicated [`blogdown::shortcode()`](https://bookdown.org/yihui/blogdown/content.html#shortcode) function.

Shortcodes are defined under `layouts/shortcodes/` and in most cases the files mustn't contain a trailing newline character which is inserted by most text
editors. To remove the trailing newline character from a shortcode file, [use the shell command
`truncate`](https://github.com/gohugoio/hugo/issues/1753#issuecomment-472118897):

``` sh
truncate -s -1 <shortcode.html>
```

### [🠅](#table-of-contents) Plain HTML

To bypass Pandoc conversion and directly write raw HTML code from inside R Markdown sites/posts, use the functions provided by the [R package
`htmltools`](https://github.com/rstudio/htmltools). If no dedicated function exists for your specific HTML code, just use
[`htmltools::HTML()`](https://rdrr.io/cran/htmltools/man/HTML.html).

## [🠅](#table-of-contents) Image optimization

### [🠅](#table-of-contents) JPEG

The banner image for a post can be set in its front matter either through the key `banner_prefix` (recommended) or through the key `banner`. In the latter case,
no thumbnails will be used. If `banner_prefix` is set, it's assumed the banner image is of type `jpg` and is available as three different optimized files:

-   `[banner_prefix]_2048.jpg` with a width of 2048 pixels
-   `[banner_prefix]_512.jpg` with a width of 512 pixels
-   `[banner_prefix]_128.jpg` with a width of 128 pixels

To create the optimized files, it's recommended to

1.  optionally clip the image to an aspect ratio (near) 1.5.

2.  place the image file under `static/img/banners/original`, scale it down to a maximum width of 2048 pixels and create thumbnails with a width of 128 and 512
    pixels respectively:

    ``` sh
    prefix="FILENAME_PREFIX"
    convert -quality 100 -resize '2048x>' ${prefix}.jpg -set filename:original %t %[filename:original]_2048.jpg
    convert -strip -quality 100 -thumbnail '512>' ${prefix}.jpg -set filename:original %t %[filename:original]_512.jpg
    convert -strip -quality 100 -thumbnail '128x>' ${prefix}.jpg -set filename:original %t %[filename:original]_128.jpg
    # move converted files one folder up and change dir
    mv ${prefix}_2048.jpg ../
    mv ${prefix}_512.jpg ../
    mv ${prefix}_128.jpg ../
    cd ..
    ```

3.  optimize image file sizes

    -   either using the "perceptual" JPEG encoder [Guetzli](https://github.com/google/guetzli/)[^readme-2] with a `--quality` setting in between `88` and `90`:

        ``` sh
        guetzli --quality 88 ${prefix}_2048.jpg ${prefix}_2048_optimized.jpg
        guetzli --quality 88 ${prefix}_512.jpg ${prefix}_512_optimized.jpg
        guetzli --quality 88 ${prefix}_128.jpg ${prefix}_128_optimized.jpg
        # overwrite unoptimized files
        mv ${prefix}_2048_optimized.jpg ${prefix}_2048.jpg
        mv ${prefix}_512_optimized.jpg ${prefix}_512.jpg
        mv ${prefix}_128_optimized.jpg ${prefix}_128.jpg
        ```

    -   or using the libjpeg-turbo fork [mozjpeg](https://github.com/mozilla/mozjpeg)[^readme-3] with the `-dc-scan-opt 2` and a `-quality` setting between `80`
        and `90`:

        ``` sh
        mozjpeg -dc-scan-opt 2 -quality 85 ${prefix}_2048.jpg > ${prefix}_2048_optimized.jpg
        mozjpeg -dc-scan-opt 2 -quality 85 ${prefix}_512.jpg > ${prefix}_512_optimized.jpg
        mozjpeg -dc-scan-opt 2 -quality 85 ${prefix}_128.jpg > ${prefix}_128_optimized.jpg
        # overwrite unoptimized files
        mv ${prefix}_2048_optimized.jpg ${prefix}_2048.jpg
        mv ${prefix}_512_optimized.jpg ${prefix}_512.jpg
        mv ${prefix}_128_optimized.jpg ${prefix}_128.jpg
        ```

    -   or just using the free [Kraken.io Online Image Optimizer](https://kraken.io/web-interface/) in its *lossy* mode[^readme-4] which [seems to do an awesome
        job](https://kraken.io/docs/lossy-optimization) (but only supports a maximum file size of 1MB on the free plan[^readme-5]; therefore it might be
        necessary to run the 2048 pixel image through `guetzli --quality 90` beforehand) or [another image optimization
        service](https://developers.google.com/web/tools/lighthouse/audits/optimize-images#services).

    mozjpeg and the Kraken.io optimizer do support [progressive encoding](https://en.wikipedia.org/wiki/JPEG#JPEG_compression) which [Guetzli
    doesn't](https://en.wikipedia.org/wiki/Guetzli#Properties). Progressive encoding is strongly recommended for the 2048 pixel width version of the image.

[^readme-2]: In general, results by Guetzli are typically 20--30 % smaller than images of equivalent quality generated by
    [libjpeg](https://en.wikipedia.org/wiki/Libjpeg).

[^readme-3]: For a CLI, install the npm module [mozjpeg-bin](https://github.com/imagemin/mozjpeg-bin).

[^readme-4]: Just make sure to choose *Expert* under *2. Select optimization mode* and then set *Chroma Subsampling* to *4:4:4* in order to avoid color loss.

[^readme-5]: There's also the free service [Jpeg.io](https://www.jpeg.io/) which is based on Kraken.io and doesn't limit the file size, but does not offer any
    advanced options like *Chroma Subsampling* settings either.

### [🠅](#table-of-contents) PNG

It's recommended to optimize `png` images using [OptiPNG](http://optipng.sourceforge.net/) (lossless)

``` sh
optipng file.png
```

or even [pngquant](https://pngquant.org/) (lossy):

``` sh
pngquant file.png
```

**Note:** You should always try lossless compression using OptiPNG first. Depending on the image, it can shrink the file size even more than the lossy pngquant
compressor.

### [🠅](#table-of-contents) SVG

It's recommended to optimize `svg` images using [SVGO](https://github.com/svg/svgo/):

``` sh
# this overwrites the original file; if you don't want this, specify an output filename using the `-o` option
svgo -i file.svg
```

## [🠅](#table-of-contents) Font icons

Instead of relying on huge pre-built font icon sets like [Font Awesome](https://fontawesome.com/), we use [Fontello](http://fontello.com/), a powerful font icon
generator. It allows us to select exactly the icons we use out of a fair amount of open source icon fonts and then generate a custom size-optimized webfont
package. The configuration to generate this custom icon set is stored in `fontello_config.json`.

To automate the Fontello webfont generation, there's a dedicated command-line interface named [fontello-cli](https://github.com/paulyoung/fontello-cli) (but we
don't use it yet).

## [🠅](#table-of-contents) Analytics

We integrate[^readme-6] [GoatCounter](https://www.goatcounter.com/), an open source web analytics platform available as a hosted service that's free for
non-commercial use. It does *by design* neither track visitors with unique identifiers, nor store any personal data or even rely on cookies -- so there's no
necessity to show any of these ugly and annoying privacy/cookie banners or the like.

Our GoatCounter stats can be viewed [**here**](https://fokus-ag.goatcounter.com?access-token=2z74m451j1w63s4w5w584b6e4x2456z433x5w) without login.

The admin panel can be accessed [here](https://fokus-ag.goatcounter.com/) (login required).

Note that since we self-host GoatCounter's JS snippet, we have to make sure to check for
[updates](https://github.com/zgoat/goatcounter/commits/master/public/count.js) from time to time[^readme-7].

[^readme-6]: This is as simple as [setting up a `goatcounter.com` account](https://www.goatcounter.com/signup) and [adding the necessary JavaScript
    code](https://www.goatcounter.com/code) to the site.

[^readme-7]: I'm [watching the script's source code for changes](https://github.com/zgoat/goatcounter/commits/master/public/count.js.atom) so I'm automatically
    notified when it's updated.

## [🠅](#table-of-contents) Shared assets

### [🠅](#table-of-contents) Counter.dev JS

To update the script, run (from the root of the repo):

``` sh
curl --silent https://cdn.counter.dev/script.js | minify --type=js | sd '\s*$' '\n' > static/counter-dev.min.js
```

### [🠅](#table-of-contents) GoatCounter JS

To update the script, run (from the root of the repo):

``` sh
curl --silent https://gc.zgo.at/count.js | minify --type=js | sd '\s*$' '\n' > static/goatcounter.min.js
```

## [🠅](#table-of-contents) License

Code and configuration in this repository is licensed under [`AGPL-3.0-or-later`](https://spdx.org/licenses/AGPL-3.0-or-later.html). See
[`LICENSE.md`](LICENSE.md).
